unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Db, DBTables, CETable, StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    CESession1: TCESession;
    CETable1: TCETable;
    Table1: TTable;
    DataSource1: TDataSource;
    Button2: TButton;
    Button3: TButton;
    StatusBar1: TStatusBar;
    NextButton: TButton;
    PriorButton: TButton;
    LastButton: TButton;
    FirstButton: TButton;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Table1_EmpNo: TCEProp;
    Table1_LastName: TCEProp;
    Table1_FirstName: TCEProp;
    Table1_PhoneExt: TCEProp;
    Table1_HireDate: TCEProp;
    Label4: TLabel;
    TestMode: TRadioGroup;
    Label5: TLabel;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CETable1BOF(Sender: TObject);
    procedure FirstButtonClick(Sender: TObject);
    procedure PriorButtonClick(Sender: TObject);
    procedure NextButtonClick(Sender: TObject);
    procedure LastButtonClick(Sender: TObject);
    procedure CETable1Change(Sender: TObject);
    procedure CETable1RecordWrite(Sender: TObject);
    procedure CETable1RecordRead(Sender: TObject);
  private
    { Private declarations }
    procedure GetContents;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.Button2Click(Sender: TObject);
Var
   CETable2: TCETable;
begin
  StatusBar1.Panels[0].Text:='Table uploading started...';
  try
    if not CESession1.IsConnected Then
       CESession1.Connect(True);

    if TestMode.ItemIndex = 0 then
    begin
      CETable1.DeleteDatabase;
      CETable1.CreateDatabase;
      CETable1.UploadTable;
      StatusBar1.Panels[0].Text:='Table uploading completed.';
      Button3.Enabled:=True;
      CETable1.Open;
      CETable1.First;
    end
    else
    begin
      CETable2 := TCETable.Create(self);
      try
         CETable1.Close;

         CETable2.TableName := 'Employe database';
         CETable2.DataSource := DataSource1;
         CETable2.DeleteDatabase;
         CETable2.CreateDatabase;

         CETable2.OnRecordWrite := CETable1RecordWrite;
         // add props dinamically
         CETable2.AddProp('CETable2_EmpNo', 'EmpNo', ceptInteger);
         CETable2.AddProp('CETable2_LastName', 'LastName', ceptLPWSTR);
         CETable2.AddProp('CETable2_FirstName', 'FirstName', ceptLPWSTR);
         CETable2.AddProp('CETable2_PhoneExt', 'PhoneExt', ceptLPWSTR);
         CETable2.AddProp('CETable2_HireDate', 'HireDate', ceptFileTime);
         CETable2.UploadTable;
         StatusBar1.Panels[0].Text:='Table uploading completed.';
         Button3.Enabled:=True;
      finally

        CETable2.Free;
      end;

    end;

  except
    on E:Exception do
    begin
      ShowMessage('Unable to upload table '+Table1.TableName+' from DBDemos: '+E.Message);
      StatusBar1.Panels[0].Text:=E.Message;
    end;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
Var
  CETable2: TCETable;
begin
  if TestMode.ItemIndex = 0 then
  begin
    Table1.Close;
    Table1.FieldDefs.Update;
    Table1.TableName:='Country'+IntToStr(GetTickCount)+'.db';
    Table1.CreateTable; // Sorry, that I make one more
                        // Country database here...
    StatusBar1.Panels[0].Text:='Table downloading started...';
    CETable1.DownloadTable;
    StatusBar1.Panels[0].Text:='Table downloading completed.';
  end
  else
  begin
    CETable2 := TCETable.Create(self);
    try
      CETable1.Close;

      CETable2.TableName := 'Employe database';

      // add props dinamically
      CETable2.AddProp('CETable2_EmpNo', '', ceptInteger);
      CETable2.AddProp('CETable2_LastName', '', ceptLPWSTR);
      CETable2.AddProp('CETable2_FirstName', '', ceptLPWSTR);
      CETable2.AddProp('CETable2_PhoneExt', '', ceptLPWSTR);
      CETable2.AddProp('CETable2_HireDate', '', ceptFileTime);

      CETable2.Open;
      CETable2.First;
      while not CETable2.Eof do
      begin
        Memo1.Lines.Add('----- '+IntToStr(CETable2.dwRecNo)+' -----');
        Memo1.Lines.Add(CETable2.PropByName('CETable2_EmpNo').AsString+', ');
        Memo1.Lines.Add(CETable2.PropByName('CETable2_LastName').AsString+', ');
        Memo1.Lines.Add(CETable2.PropByName('CETable2_FirstName').AsString+', ');
        Memo1.Lines.Add(CETable2.PropByName('CETable2_PhoneExt').AsString+', ');
        Memo1.Lines.Add(CETable2.PropByName('CETable2_HireDate').AsString);
        Application.ProcessMessages;
        CETable2.Next;
      end;
    finally
      CETable2.Free;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CESession1.Connect(True);
end;

procedure TForm1.CETable1BOF(Sender: TObject);
begin
  with CETable1 do
  Begin
    FirstButton.Enabled:=not BOF;
    PriorButton.Enabled:=not BOF;
    LastButton.Enabled:=not EOF;
    NextButton.Enabled:=not EOF;
  End;
end;

procedure TForm1.FirstButtonClick(Sender: TObject);
begin
  CETable1.First;
end;

procedure TForm1.PriorButtonClick(Sender: TObject);
begin
  CETable1.Prior;
end;

procedure TForm1.NextButtonClick(Sender: TObject);
begin
  CETable1.Next;
end;

procedure TForm1.LastButtonClick(Sender: TObject);
begin
  CETable1.Last;
end;

procedure TForm1.GetContents;
Var
  i: integer;
  Prop: TCEProp;
Begin
  Memo1.Clear;
  if CETable1.dwRecNo<>DWORD(-1) Then
  begin
   with CETable1 do
      for i:=0 to PropsList.Count-1 do
      Begin
         Prop:=TCEProp(PropsList[i]);
         Memo1.Lines.Add(Prop.PropName+': '+Prop.AsString+', ');
      End;

   StatusBar1.Panels[0].Text:='Record Nr: '+IntToStr(CETable1.dwRecNo);
   Application.ProcessMessages;
  end;
End;

procedure TForm1.CETable1Change(Sender: TObject);
begin
  GetContents;
end;

procedure TForm1.CETable1RecordWrite(Sender: TObject);
begin
  StatusBar1.Panels[0].Text:='Record Nr: '+IntToStr(Table1.RecNo);
  Application.ProcessMessages;
end;

procedure TForm1.CETable1RecordRead(Sender: TObject);
begin
  StatusBar1.Panels[0].Text:='Record Nr: '+IntToStr(CETable1.dwRecNo);
  Application.ProcessMessages;
end;

end.
